﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;

namespace UltraStatusBarWithProgressBar
{
    public partial class Form1 : Form
    {
        private BackgroundWorker backgroundWorker1;
        public Form1()
        {
            InitializeComponent();
            this.backgroundWorker1 = new System.ComponentModel.BackgroundWorker();
            backgroundWorker1.DoWork += new DoWorkEventHandler(backgroundWorker1_DoWork);
        }

        void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            for (int i = 0; i <= 100; i++)
            {
                // Just do delay in the background process
                DateTime tempValue = DateTime.Now;
                while (tempValue.AddSeconds(1) > DateTime.Now)
                {
                    Debug.WriteLine(DateTime.Now.ToString());
                }
                this.ultraStatusBar1.Panels[0].ProgressBarInfo.Value = i;
                this.ultraStatusBar1.Panels[1].ProgressBarInfo.Value = i;

                this.ultraStatusBar1.Invoke((MethodInvoker)delegate()
                {
                    this.ultraStatusBar1.Panels[1].Text = "Loading " + ultraStatusBar1.Panels[1].ProgressBarInfo.Value.ToString() + " %";
                });
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            this.backgroundWorker1.RunWorkerAsync();
        }
    }
}
